#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	Fonctions pour crer des images cliquables  3 positions:
	(Normale, Survol, Clique)

	Complmentaire de 3StatIcon.au3 et similaire dans l'utilisation
	Interet: utiliser des images au lieu d'icones (Surtout png - transparence -)
	Problme: ne peut exploiter des ressources prsentes dans une dll ou un exe

 Todo:
	- Ajouter support de fichiers de ressources pour les images (je pense  l'extraction
		de handles d'image ou de bitmap d'une dll/exe et l'exploiter grce  _SetHImage

#ce ----------------------------------------------------------------------------
#include-once

#include <perso\Icons.au3>
#include <perso\GuiCtrlOnHover.au3>
#include <Array.au3>

Global $__3SP_Array
__3StatPic_InitMainArray()

#cs
	$__3SP_Array[$i][0] = Handle du control (GuiCtrlPic)
	$__3SP_Array[$i][1] = Chemin de l'image *normale*
	$__3SP_Array[$i][2] = Chemin de l'image *survol*
	$__3SP_Array[$i][3] = Chemin de l'image *clique*
#ce

; ##############################################################

Func _3StatPic_Create($sImg1, $iX, $iY, $iW, $iH, $sImg2 = Default, $sImg3 = Default, $iStyle = Default, $iExtStyle = Default)
	If $sImg2 = Default Then $sImg2 = $sImg1
	If $sImg3 = Default Then $sImg3 = $sImg1

	Local $hCtrl = GuiCtrlCreatePic("", $iX, $iY, $iW, $iH, $iStyle, $iExtStyle)
	_GUICtrl_OnHoverRegister($hCtrl, "__3StatPic_OnHoverFunction", "__3StatPic_OnHoverFunction", _
									"__3StatPic_OnClickFunction", "__3StatPic_OnClickFunction", 0)
	_SetImage($hCtrl, $sImg1)

	__3StatPic_ArrayAdd($hCtrl, $sImg1, $sImg2, $sImg3)

	Return $hCtrl
EndFunc

Func _3StatPic_ChangeImg($hCtrl, $sImg1 = Default, $sImg2 = Default, $sImg3 = Default)
	Local $iCtrlIndex = __3StatPic_hCtrlToIndex($hCtrl)
	If $iCtrlIndex = -1 Then Return 0
	If $sImg1 <> Default Then $__3SP_Array[$iCtrlIndex][1] = $sImg1
	If $sImg2 <> Default Then $__3SP_Array[$iCtrlIndex][2] = $sImg2
	If $sImg3 <> Default Then $__3SP_Array[$iCtrlIndex][3] = $sImg3
	Return 1
EndFunc

Func _3StatPic_Delete($hCtrl)
	__3StatPic_ArrayDel($hCtrl)
	Return GuiCtrlDelete($hCtrl)
EndFunc

; ##############################################################
; ################## Internal use only #########################
; ##############################################################

Func __3StatPic_OnClickFunction($hCtrl, $iClickMode)
	Local $iCtrlIndex = __3StatPic_hCtrlToIndex($hCtrl)
	If $iCtrlIndex = -1 Then Return 0

	Switch $iClickMode
		Case 1 ; pressed
			_SetImage($hCtrl, $__3SP_Array[$iCtrlIndex][3])
		Case 2 ; released
			_SetImage($hCtrl, $__3SP_Array[$iCtrlIndex][2])
	EndSwitch
EndFunc

Func __3StatPic_OnHoverFunction($hCtrl, $iHoverMode, $hWin)
	Local $iCtrlIndex = __3StatPic_hCtrlToIndex($hCtrl)
	If $iCtrlIndex = -1 Then Return 0

	Switch $iHoverMode
		Case 1 ; hover
			_SetImage($hCtrl, $__3SP_Array[$iCtrlIndex][2])
		Case 2 ; leave
			_SetImage($hCtrl, $__3SP_Array[$iCtrlIndex][1])
	EndSwitch
EndFunc

Func __3StatPic_ArrayAdd($hCtrl, $sImg1, $sImg2, $sImg3)
	Local $iNbr = $__3SP_Array[0][0]
	Redim $__3SP_Array[$iNbr + 2][4]
	$__3SP_Array[$iNbr + 1][0] = $hCtrl
	$__3SP_Array[$iNbr + 1][1] = $sImg1
	$__3SP_Array[$iNbr + 1][2] = $sImg2
	$__3SP_Array[$iNbr + 1][3] = $sImg3
	$__3SP_Array[0][0] = $iNbr + 1
EndFunc

Func __3StatPic_ArrayDel($hCtrl)
	For $i = 1 To $__3SP_Array[0][0]
		If $__3SP_Array[$i][0] = $hCtrl Then
			_ArrayDelete($__3SP_Array, $i)
			If Not IsArray($__3SP_Array) Then __3StatPic_InitMainArray()
			Return 1
		EndIf
	Next
	Return 0
EndFunc

Func __3StatPic_hCtrlToIndex($hCtrl)
	Local $iCtrlIndex = -1
	For $i = 1 To $__3SP_Array[0][0]
		If $__3SP_Array[$i][0] = $hCtrl Then
			$iCtrlIndex = $i
			ExitLoop
		EndIf
	Next
	Return $iCtrlIndex
EndFunc

Func __3StatPic_InitMainArray()
	Global $__3SP_Array[1][4]
	$__3SP_Array[0][0] = 0
EndFunc
